#Ifndef _creatures_bi_
#Define _creatures_bi_
#Include "utils.bi"

Type creature_t
	opcodes As String
	program As String
	max_len As UInteger
	x_positions As UInteger Ptr
	y_positions As UInteger Ptr
	x As Integer
	y As Integer
	orientation As UInteger
	PC As UInteger

	energy As Integer
	life As Integer
	fooded As UInteger
	blocked As UInteger
	sleeping As UInteger
	sleep_count As UInteger
	score As Single
	'world As IMAGE Ptr

	As timer_t heardbeat
	As Double borntime
	As UInteger lifetime

	id As UInteger

	Declare Constructor()
	Declare Constructor(size As UInteger)
	Declare Destructor()
	Declare Sub execute_one_step(c As creature_t ptr)
	Declare Sub mutate(mutate_rate As Single)
	Declare Function crossover(c1 As creature_t, c2 As creature_t) As String
	Declare Function look_for_food() As UInteger
	Declare Function look_for_creature() As UInteger
	Declare Sub render()
	Declare Sub init()
End Type
Constructor creature_t()
program="P"'"fLMBRM"
borntime=Timer
lifetime=1
heardbeat.set_reset_interval(Rnd)'+Rnd*1)
id=Timer*1000
x=Int(Rnd*400)
y=Int(Rnd*400)
life=100
max_len=21
energy=max_len*10
orientation=Int(Rnd*4)
x_positions=New UInteger[max_len]
y_positions=New UInteger[max_len]
opcodes="PMLREFfBbZ?!A"
fooded=1
score =0
End Constructor
Constructor creature_t(max_size As UInteger)
program="P"
borntime=Timer
lifetime=0.000001
max_len=max_size
x_positions=New UInteger[max_size]
y_positions=New UInteger[max_size]
id=Timer*1000
x=Int(Rnd*400)
y=Int(Rnd=400)
life=100
energy=max_len*10
opcodes="MLREFfBbZ?!A"
score =0
End Constructor
Destructor creature_t()
Delete [] x_positions
Delete [] y_positions
End Destructor

Sub creature_t.init()
	'Dim x_steps(0 To 4) As Integer={0,1,0,-1}
	'Dim y_steps(0 To 4) As Integer={-1,0,1,0}
	'Dim xtmp As Integer=x
	'Dim ytmp As Integer=y
	'Dim As UInteger tmpo=orientation+2
	'tmpo=tmpo Mod 4
	id=1
	For i As UInteger=0 To Len(program)
		'xtmp+=x_steps(tmpo)
		'ytmp+=y_steps(tmpo)
		'If ytmp<0 Then ytmp=399
		'If ytmp>399 Then ytmp=0
		'If xtmp<0 Then xtmp=399
		'If xtmp>399 Then xtmp=0

		'x_positions[i]=xtmp
		'y_positions[i]=ytmp
		id+=((Asc(Mid(program,i,1))^i)Xor &h77777777)
	Next
End Sub
Sub creature_t.render()
	For i As UInteger=0 To Len(program)
		PSet world ,(x_positions[i],y_positions[i]),&hff000000
		PSet world ,(x_positions[i],y_positions[i]),id
	Next
	PSet world ,(x_positions[Len(program)],y_positions[Len(program)]),&hff000000
End Sub



Function creature_t.look_for_food() As UInteger
	Dim x_steps(0 To 4) As Integer={0,1,0,-1}
	Dim y_steps(0 To 4) As Integer={-1,0,1,0}
	Dim As Integer xtmp=x
	Dim As Integer ytmp=y
	For i As UInteger=0 To 25
		xtmp+=x_steps(orientation)
		ytmp+=y_steps(orientation)
		If ytmp<0 Then ytmp=399
		If ytmp>399 Then ytmp=0
		If xtmp<0 Then xtmp=399
		If xtmp>399 Then xtmp=0
		If Point(xtmp,ytmp,world )<>id And Point(xtmp,ytmp,world )=&Hff00ff00 And _
			Point(xtmp,ytmp,world )<>&hff000000 And Point(xtmp,ytmp,world )<>&hffffffff Then 'is the point not you not food not wall and not vacuum
			Return 1
		EndIf
	Next
	Return 0
End Function
Function creature_t.look_for_creature() As UInteger
	Dim x_steps(0 To 4) As Integer={0,1,0,-1}
	Dim y_steps(0 To 4) As Integer={-1,0,1,0}
	Dim As Integer xtmp=x
	Dim As Integer ytmp=y
	For i As UInteger=0 To 25
		xtmp+=x_steps(orientation)
		ytmp+=y_steps(orientation)
		If ytmp<0 Then ytmp=399
		If ytmp>399 Then ytmp=0
		If xtmp<0 Then xtmp=399
		If xtmp>399 Then xtmp=0
		If Point(xtmp,ytmp,world )<>id And Point(xtmp,ytmp,world )<>&hff00ff00 And _
			Point(xtmp,ytmp,world )<>&hff000000 And Point(xtmp,ytmp,world )<>&hffffffff Then 'is the point not you not food not wall and not vacuum
			Return 1
		EndIf
	Next
	Return 0
End Function

Sub creature_t.execute_one_step(c As creature_t Ptr)
	Dim x_steps(0 To 4) As Integer={0,1,0,-1}
	Dim y_steps(0 To 4) As Integer={-1,0,1,0}
	If energy<=0 Then
		Exit Sub
	EndIf
	If sleeping=1 And sleep_count<32 Then
		sleep_count+=1
		Exit Sub
	Else
		sleeping=0
		sleep_count=0
		energy-=1
	EndIf
	If program[PC]=Asc("Z") Then sleeping=1						'sleep for 32 world ticks
	If program[PC]=Asc("P") Then energy+=2:mutate(0.001):Exit sub		'Photosynthese give 1 energie per world tick but have a 1% mutate chance caused from UV rays ;D
	If program[PC]=Asc("M") Then										'move one step forward
		Dim As Integer xtmp=x
		Dim As Integer ytmp=y
		xtmp+=x_steps(orientation)
		ytmp+=y_steps(orientation)
		If ytmp<0 Then ytmp=399
		If ytmp>399 Then ytmp=0
		If xtmp<0 Then xtmp=399
		If xtmp>399 Then xtmp=0

		If Point(xtmp,ytmp,world )=&hff000000 _
			Or Point(xtmp,ytmp,world )=&hff00ff00 Then
			blocked=0
		Else
			blocked=1
			pc+=1
			Exit Sub
		EndIf

		If Point(xtmp,ytmp,world )=&Hff00ff00 Then
			energy+=Len(program)*25
			fooded+=1
			food-=1
		EndIf
		x+=x_steps(orientation)
		y+=y_steps(orientation)
		For i As Integer=Len(program) To 0 Step -1
			x_positions[i+1]=x_positions[i]
			y_positions[i+1]=y_positions[i]
		Next
		x_positions[0]=x
		y_positions[0]=y
		blocked=0
		'		x_positions(0)=x
		'		y_positions(0)=y
		energy-=1
		Exit Sub
	EndIf

	If program[PC]=Asc("L") Then											'turn left 90 degrees
		orientation-=1
		orientation = orientation And &b11
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("R") Then											'turn right 90 degrees
		orientation+=1
		orientation = orientation And &b11
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("F") Then											'execute next cell only Food is in front of you
		If look_for_food()=0 Then
			PC+=2
			energy-=1
			Exit Sub
		EndIf
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("f") Then											'execute next cell only no Food is in front of you
		If look_for_food()=1 Then
			PC+=2
			energy-=1
			Exit Sub
		EndIf
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("B") Then											'execute next cell only last move was Blocked
		If blocked=0 Then
			PC+=2
			energy-=1
			Exit Sub
		EndIf
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("b") Then											'execute next cell only last move was not Blocked
		If blocked=1 Then
			PC+=2
			energy-=1
			Exit Sub
		EndIf
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("E") Then											'end programm/begin in frontcell
		PC=-1:energy-=1
	EndIf
	If program[PC]=Asc("?") Then											'execute next 7 cells only if a no other creature is in front of you
		If look_for_creature()=1 Then
			PC+=8
			energy-=1
			Exit Sub
		EndIf
		PC+=1
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("!") Then											''execute next 7 cells only if a other creature is in front of you
		If look_for_creature()=0 Then
			PC+=8
			energy-=1
			Exit Sub
		EndIf
		PC+=1
		energy-=1
		Exit Sub
	EndIf
	If program[PC]=Asc("A") Then											'move one step forward and attak the cell, get many energy (attack)
		If blocked=0 Then
			Dim As Integer xtmp=x
			Dim As Integer ytmp=y
			xtmp+=x_steps(orientation)
			ytmp+=y_steps(orientation)
			If ytmp<0 Then ytmp=399
			If ytmp>399 Then ytmp=0
			If xtmp<0 Then xtmp=399
			If xtmp>399 Then xtmp=0
			If Point(xtmp,ytmp,world )<>id And _
				Point(xtmp,ytmp,world )<>&hffffffff Then 'is the point not you not food not wall and not vacuum
				For i As UInteger=0 To 127
					If Point(xtmp,ytmp,world )=c[i].id Then
						energy+=Len(c[i].program)*50
						fooded+=Len(c[i].program)
						c[i].energy=0
					EndIf
				Next
			endif
			x=xtmp
			y=ytmp
			For j As Integer=Len(program) To 0 Step -1
				x_positions[j+1]=x_positions[j]
				y_positions[j+1]=y_positions[j]
			Next
			x_positions[0]=x
			y_positions[0]=y
		EndIf
		energy-=1
		Exit Sub
	EndIf

	PC+=1
	If PC>Len(program) Then PC=PC Mod Len(program)

	If x<0 Then x=399
	If x>399 Then x=0
	If y<0 Then y=399
	If y>399 Then y=0

	lifetime+=1
	score = fooded
	If energy<=0 Then												'dead creatures are food
		For i As UInteger=0 To Len(program)-1
			If Point(x_positions[i],y_positions[i],world )<>&hff00ff00 Then
				PSet world ,(x_positions[i],y_positions[i]),&hff000000
				x_positions[i]=0
				y_positions[i]=0
				'food+=1
			endif
		Next
	EndIf
End Sub

Sub creature_t.mutate(mutate_rate As Single)
	For i As UInteger=0 To Len(program)
		If Rnd<mutate_rate Then
			Mid(program,i,1)=Mid(opcodes,Int(Rnd*Len(opcodes)),1)
		EndIf
	Next
	If Rnd<mutate_rate Then
		program+=Mid(opcodes,1+Int(Rnd*Len(opcodes)),1)
	EndIf
	If Rnd<mutate_rate Then
		program=Mid(opcodes,1+Int(Rnd*Len(opcodes)),1)+program
	EndIf
	If Rnd<mutate_rate Then
		Dim posi As UInteger=Int(Rnd*Len(program))
		Dim p1 As String=Left(program,posi)
		Dim p2 As String=Right(program,posi)
		program=p1+Mid(opcodes,1+Int(Rnd*Len(opcodes)),1)+p2
	EndIf
	If Rnd<mutate_rate Then
		program=Left(program,Len(program)-1)
	EndIf
	If Rnd<mutate_rate Then
		program=Right(program,Len(program)-1)
	EndIf
	If program="" Then program="P"
	program=Left(program,max_len)
End Sub
Function creature_t.crossover(c1 As creature_t, c2 As creature_t) As String
	Dim tmp As String
	Dim As UInteger maxlen=IIf(Len(c1.program)>Len(c2.program),Len(c1.program),Len(c2.program))
	For i As UInteger=0 To maxlen
		If Rnd<0.5 Then
			tmp+=Mid(c2.program,i,1)
		Else
			tmp+=Mid(c1.program,i,1)
		EndIf
	Next
	tmp=Left(tmp,max_len)
	Return tmp
End Function
#EndIf